(define laml-execution-mode 'safe)  ; used by general.scm



; Ad hoc definition of the error function.
  
(define to-top-level #f)

(call-with-current-continuation 
  (lambda (f)
    (set! to-top-level f)))

(define (error mes)
  (display (string-append "Error: "))
  (to-top-level mes)
)



; Ad hoc definition of the bound function.  With an unfortunate extra error message in case of error.

(define (bound? symbol)
  (call-with-current-continuation
    (lambda (return)
     (let ((success #f))
      (dynamic-wind
        (lambda () 'do-nothing)
        (lambda () (eval symbol (interaction-environment)) (set! success #t))
        (lambda ()
          (return success))
      )))))

(define (bound? symbol)
  #t)
        
  