(define rp1 (make-object 'x 5 'y 10))

(add-member! rp1 'move
   (function (dx dy) 
     (set-field! this-object 'x (+ x dx))
     (set-field! this-object 'y (+ y dy))))

(define rectangular-point (kappa rp1))
(add-member! rectangular-point 'R (function () (sqrt ( + (square x) (square y)))))
(add-member! rectangular-point 'A (function () (atan y x)))
(add-member! rectangular-point 'X (function () x))
(add-member! rectangular-point 'Y (function () y))

(define rp2 (new-object rectangular-point))

(as-instance-of-class! rp1 rectangular-point)

(define pi 3.14159)
(define pp1 (make-object 'r 5 'a (/ pi 2)))

(define polar-point (kappa pp1))

(define pp2 (new-object polar-point))
(define pp3 (new-object polar-point 'r 6 'a pi))
(define pp4 (new-object polar-point 'r 6 'a pi))

(add-member! polar-point 'R (function () r))
(add-member! polar-point 'A (function () a))
(add-member! polar-point 'X (function () (* (cos a) r)))
(add-member! polar-point 'Y (function () (* (sin a) r)))

(as-instance-of-class! pp1 polar-point)

(define point (generalize (list polar-point rectangular-point) '()))







